// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

/* Generated by Together */

package de.uka.ilkd.key.casetool;

import de.uka.ilkd.key.proof.mgt.Contractable;


public class DefaultReprModelMethodImpl implements ReprModelMethod {


    private ReprModelClass containingClass;
    private String name;
    private boolean isVoid;
    private boolean isConstructor;
    private boolean isPrivate;
    private String precond = "";
    private String postcond = "";
    private String modifies = "";
    private ReprModelMethod method;
    private ReprModelMethod parentMethod;

    DefaultReprModelMethodImpl(ReprModelClass containingClass,
			       ReprModelMethod method,
			       ReprModelMethod parentMethod,
			       String name,
			       boolean isVoid,
			       boolean isConstructor,
			       boolean isPrivate) {
	this.method = method;
	this.parentMethod = parentMethod;
	this.containingClass = containingClass;
	this.name = name;
	this.isVoid = isVoid;	
	this.isConstructor = isConstructor;
	this.isPrivate = isPrivate;
    }

    public ReprModelClass getContainingClass() {
	return containingClass;
    }

    public String getContainingClassName() {
	return containingClass.getClassName();
    }

    public String getContainingPackage() {
	return containingClass.getContainingPackage();
    }
    
    public String getCallSignature() {
	return method.getCallSignature();
    }

    public String getParameterNameAt(int i) {
	return method.getParameterNameAt(i);
    }

    public String getParameterTypeAt(int i) {
	return method.getParameterTypeAt(i);
    }

    public String getCallSignature(boolean translateJavaType2OCLTypes) {
	return method.getCallSignature(translateJavaType2OCLTypes);
    }

    public String getName() {
	return name;
    }

    public boolean isVoid() {
	return isVoid;
    }

    public boolean isConstructor() {
	return isConstructor;
    }

    public boolean isPrivate() {
	return isPrivate;
    }
      
    public String getMyPreCond() {
	return precond;
    }

    public void setMyPreCond(String precond) {
	this.precond = precond;
    }

    public boolean isQuery() {
	return false;
    }

    public String getParentPreCond() {
	return method.getMyPreCond();
    }

    public ReprModelMethod getParentMethod() {
	return parentMethod;
    }

    public String getMyPostCond() {
	return postcond;
    }

    public void setMyPostCond(String postcond) {
	this.postcond = postcond;
    }

    public String getMyModifClause() {
	return modifies;
    }

    public void setMyModifClause(String modifies) {
	this.modifies = modifies;
    }

    public String getParentPostCond() {
	return method.getMyPostCond();
    }

    public String getMyGFAbs() {
	throw new RuntimeException("Method getMyGFAbs not "+
				   "implemented in this default "+
				   "implementation.");
    }

    public void setMyGFAbs(String abs) {
	throw new RuntimeException("Method setMyGFAbs not "+
				   "implemented in this default "+
				   "implementation.");
    }

    public String getActXmifile() {
	throw new RuntimeException("Method getActXmifile not "+
				   "implemented in this default "+
				   "implementation.");
    }

    public boolean hasOrigParent() {
	throw new RuntimeException("Method hasOrigParent not "+
				   "implemented in this default "+
				   "implementation.");
	//	return hasOrigParent;
    }
    
    public boolean equalContractable(Contractable c) {
    	return equals(c);
    }
    
    
}
