// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//


/** @author Kristofer Johannisson */ 


package de.uka.ilkd.key.casetool.together.scripts.menuextension;

/* import de.uka.ilkd.key.casetool.FunctionalityOnModel; */
import javax.swing.ProgressMonitor;
import org.apache.log4j.Logger;
import de.uka.ilkd.key.casetool.ReprModelClass;
import de.uka.ilkd.key.casetool.together.TogetherGFInterface;
import de.uka.ilkd.key.ocl.gf.CallbackClassInv;
import de.uka.ilkd.key.ocl.gf.GFinterface;
import de.uka.ilkd.key.ocl.gf.Utils;

public class ClassMenuPoint7 extends ClassMenu {
        protected static Logger timelogger = Logger.getLogger("de.uka.ilkd.key.ocl.gf.Timer");
        protected static Logger logger = Logger.getLogger("key.ocl.gf");
        
    public String getMenuEntry(){
	return "Edit Invariant [GF]";
    }

    protected String runCore(ReprModelClass aReprModelClass) {
            if (timelogger.isDebugEnabled()) {
                    timelogger.debug(System.currentTimeMillis() + "  ObMenuPoint6 runCore");
            }
            if (logger.isDebugEnabled()) {            
                    logger.debug("Class: " + aReprModelClass.getFullClassName());
            }
            ProgressMonitor pm = new ProgressMonitor(null,
                            "Loading the GF editor for OCL",
                            "", 0, 9700);
            Utils.tickProgress(pm, 1, "Initializing TogetherGFInterface");
            
        CallbackClassInv cci = new CallbackClassInv(aReprModelClass);
        String name = aReprModelClass.getClassName();
        String pack = aReprModelClass.getContainingPackage();
        String inv = aReprModelClass.getMyInv();
        String abs = aReprModelClass.getMyInvGFAbs();
        
        // aReprModelClass.setMyInvGFAbs("just testing...");
        
    //    return (new GFinterface()).editClassInvariant(aReprModelClass.getClassName(),
    //    	aReprModelClass.getMyInv());
    	return (new TogetherGFInterface()).editClassInvariant(name, pack, inv, cci, pm, abs);
    }
}
