// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2004 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
package de.uka.ilkd.key.proof.mgt;

import de.uka.ilkd.key.proof.Proof;
import de.uka.ilkd.key.proof.init.*;

public class NonInterferenceCheck {

    private Proof proof1, proof2;

    public NonInterferenceCheck(BasicTask[] tasks) {
        if (tasks.length != 2) throw new IllegalStateException(
            "Non-Interference checker needs 2 proofs, got "+tasks.length);
        proof1 = tasks[0].proof();
        proof2 = tasks[1].proof();
        // XXX: test if proofs in same env.
    }
    
    public void run() {
        ProofEnvironment env = proof1.env();
        NonInterferencePO nipo = new NonInterferencePO(env,proof1,proof2);
        String res = ProblemInitializer.startProver(nipo, env);
        if (!"".equals(res)) System.err.println(res);
        nipo.createSubgoals();
    }

}
